/* CellScrollView.h:
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or  implied, as to its
 * fitness for any particular use.
 *
 *
 * The CellScrollView is a subclass of scrollview that maintains a set of
 * custom cells in a matrix.  The contents of each cell is derived from an
 * external list of objects.  This approach separates the underlying data
 * structure from the user interface.
 */

#import <appkit/appkit.h>
#import <objc/List.h>

@interface CellScrollView:ScrollView
{
  id	cellMatrix;		/* underying matrix of FooCells */
}

- init;

- initFrame:(const NXRect *)frameRect;

- free;

- cellMatrix;
/*
 * return the underlying matrix of FooCells
 */

- loadCellsFrom:(List *)fooObjects;
/*
 * Reload and redisplay the list of FooObjects.
 */

@end
